#include <ppltasks.h>
#include <iostream>
#include <string>

using namespace Concurrency;
using namespace std;

task<wstring> write_to_string()
{
	// Ʈ shared_ptr   ̸  ĸϿ
	//  ½ũ     
	auto s = make_shared<wstring>(L"Value 1");
	return create_task([s]
	{
		wcout << L"Current value: " << *s << endl;

		// ĸ shared_ptr  ϴ  
		*s = L"Value 2";

	}).then([s]
	{
		wcout << L"Current value: " << *s << endl;

		// ĸ shared_ptr  ϴ  Ͽ ȯ
		*s = L"Value 3";
		return *s;
	});
}

int wmain()
{
	// ½ũ  Լ ȣ
	auto t = write_to_string();

	// ۾      
	wcout << L"Final value: " << t.get() << endl;
}
