#include <ppl.h>
#include <agents.h>
#include <iostream>

using namespace Concurrency;
using namespace std;

int wmain()
{
    combinable<int> dummy1, dummy2;
    int threadCount1 = 0, threadCount2 = 0;

    // Ϲ  
    parallel_for(0, 100000, [&dummy1](int i) {

        //      ۾
        dummy1.local();

        // ۾ ...
    });

    //   ۾ ó    
    dummy1.combine_each([&threadCount1](int num) {
        ++threadCount1;
    });

    wcout << L"First loop thread count: " << threadCount1 << endl;

    // ޽  
    overwrite_buffer<int> buffer;

    //   ȿ ۿ  
    parallel_for(0, 100000, [&buffer, &dummy2](int i) {

        //      ۾
        dummy2.local();

        // Concurrency::send Լ  忡 ÿ
        // ȣ   ŷ  ȭȴ.
        send(buffer, i);
    });

    //   ۾ ó    
    dummy2.combine_each([&threadCount2](int num) {
        ++threadCount2;
    });

    wcout << L"Second loop thread count: " << threadCount2 << endl;
}
